//
//  PSLoginModulePSLoginModuleAssembly.m
//  PeopleSay
//
//  Created by Sergey Buravtsov on 06/06/2016.
//  Copyright © 2016 PeopleSay. All rights reserved.
//

#import "PSLoginModuleAssembly.h"

#import "PSLoginModuleViewController.h"
#import "PSLoginModuleInteractor.h"
#import "PSLoginModulePresenter.h"
#import "PSLoginModuleRouter.h"

#import <ViperMcFlurry/ViperMcFlurry.h>

@implementation PSLoginModuleAssembly

- (PSLoginModuleViewController *)viewLoginModuleModule {
    return [TyphoonDefinition withClass:[PSLoginModuleViewController class]
                          configuration:^(TyphoonDefinition *definition) {
                              [definition injectProperty:@selector(output)
                                                    with:[self presenterLoginModuleModule]];
                              [definition injectProperty:@selector(moduleInput)
                                                    with:[self presenterLoginModuleModule]];
                          }];
}

- (PSLoginModuleInteractor *)interactorLoginModuleModule {
    return [TyphoonDefinition withClass:[PSLoginModuleInteractor class]
                          configuration:^(TyphoonDefinition *definition) {
                              [definition injectProperty:@selector(output)
                                                    with:[self presenterLoginModuleModule]];
                          }];
}

- (PSLoginModulePresenter *)presenterLoginModuleModule {
    return [TyphoonDefinition withClass:[PSLoginModulePresenter class]
                          configuration:^(TyphoonDefinition *definition) {
                              [definition injectProperty:@selector(view)
                                                    with:[self viewLoginModuleModule]];
                              [definition injectProperty:@selector(interactor)
                                                    with:[self interactorLoginModuleModule]];
                              [definition injectProperty:@selector(router)
                                                    with:[self routerLoginModuleModule]];
                          }];
}

- (PSLoginModuleRouter *)routerLoginModuleModule {
    return [TyphoonDefinition withClass:[PSLoginModuleRouter class]
                          configuration:^(TyphoonDefinition *definition) {
                              [definition injectProperty:@selector(transitionHandler)
                                                    with:[self viewLoginModuleModule]];
                          }];
}

@end
