//
//  PSLoginModulePSLoginModulePresenterTests.m
//  PeopleSay
//
//  Created by Sergey Buravtsov on 06/06/2016.
//  Copyright © 2016 PeopleSay. All rights reserved.
//

#import <XCTest/XCTest.h>
#import <OCMock/OCMock.h>

#import "PSLoginModulePresenter.h"

#import "PSLoginModuleViewInput.h"
#import "PSLoginModuleInteractorInput.h"
#import "PSLoginModuleRouterInput.h"

@interface PSLoginModulePresenterTests : XCTestCase

@property (nonatomic, strong) PSLoginModulePresenter *presenter;

@property (nonatomic, strong) id mockInteractor;
@property (nonatomic, strong) id mockRouter;
@property (nonatomic, strong) id mockView;

@end

@implementation PSLoginModulePresenterTests

#pragma mark - Настройка окружения для тестирования

- (void)setUp {
    [super setUp];

    self.presenter = [[PSLoginModulePresenter alloc] init];

    self.mockInteractor = OCMProtocolMock(@protocol(PSLoginModuleInteractorInput));
    self.mockRouter = OCMProtocolMock(@protocol(PSLoginModuleRouterInput));
    self.mockView = OCMProtocolMock(@protocol(PSLoginModuleViewInput));

    self.presenter.interactor = self.mockInteractor;
    self.presenter.router = self.mockRouter;
    self.presenter.view = self.mockView;
}

- (void)tearDown {
    self.presenter = nil;

    self.mockView = nil;
    self.mockRouter = nil;
    self.mockInteractor = nil;

    [super tearDown];
}

#pragma mark - Тестирование методов PSLoginModuleModuleInput

#pragma mark - Тестирование методов PSLoginModuleViewOutput

- (void)testThatPresenterHandlesViewReadyEvent {
    // given


    // when
    [self.presenter didTriggerViewReadyEvent];

    // then
    OCMVerify([self.mockView setupInitialState]);
}

#pragma mark - Тестирование методов PSLoginModuleInteractorOutput

@end
