//
//  PSLoginModulePSLoginModuleViewControllerTests.m
//  PeopleSay
//
//  Created by Sergey Buravtsov on 06/06/2016.
//  Copyright © 2016 PeopleSay. All rights reserved.
//

#import <XCTest/XCTest.h>
#import <OCMock/OCMock.h>

#import "PSLoginModuleViewController.h"

#import "PSLoginModuleViewOutput.h"

@interface PSLoginModuleViewControllerTests : XCTestCase

@property (nonatomic, strong) PSLoginModuleViewController *controller;

@property (nonatomic, strong) id mockOutput;

@end

@implementation PSLoginModuleViewControllerTests

#pragma mark - Настройка окружения для тестирования

- (void)setUp {
    [super setUp];

    self.controller = [[PSLoginModuleViewController alloc] init];

    self.mockOutput = OCMProtocolMock(@protocol(PSLoginModuleViewOutput));

    self.controller.output = self.mockOutput;
}

- (void)tearDown {
    self.controller = nil;

    self.mockOutput = nil;

    [super tearDown];
}

#pragma mark - Тестирование жизненного цикла

- (void)testThatControllerNotifiesPresenterOnDidLoad {
	// given

	// when
	[self.controller viewDidLoad];

	// then
	OCMVerify([self.mockOutput didTriggerViewReadyEvent]);
}

#pragma mark - Тестирование методов интерфейса

#pragma mark - Тестирование методов PSLoginModuleViewInput

@end
